datablock AudioProfile(bigCowSound) //equip
{
   filename    = "./bigcow.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(kenko1Sound : bigCowSound) //explosions
{
   filename    = "./explode3.wav";
};
datablock AudioProfile(kenko2Sound : bigCowSound)
{
   filename    = "./explode4.wav";
};
datablock AudioProfile(kenko3Sound : bigCowSound)
{
   filename    = "./explode5.wav";
};

//big mcfucking particle
datablock particleData(kenkoExplosionFrame2)
{
	textureName = "./spritesheet/frame2.png";
};
datablock particleData(kenkoExplosionFrame3)
{
	textureName = "./spritesheet/frame3.png";
};
datablock particleData(kenkoExplosionFrame4)
{
	textureName = "./spritesheet/frame4.png";
};
datablock particleData(kenkoExplosionFrame5)
{
	textureName = "./spritesheet/frame5.png";
};
datablock particleData(kenkoExplosionFrame6)
{
	textureName = "./spritesheet/frame6.png";
};
datablock particleData(kenkoExplosionFrame7)
{
	textureName = "./spritesheet/frame7.png";
};
datablock particleData(kenkoExplosionFrame8)
{
	textureName = "./spritesheet/frame8.png";
};
datablock particleData(kenkoExplosionFrame9)
{
	textureName = "./spritesheet/frame9.png";
};
datablock particleData(kenkoExplosionFrame10)
{
	textureName = "./spritesheet/frame10.png";
};
datablock particleData(kenkoExplosionFrame11)
{
	textureName = "./spritesheet/frame11.png";
};
datablock particleData(kenkoExplosionFrame12)
{
	textureName = "./spritesheet/frame12.png";
};
datablock particleData(kenkoExplosionFrame13)
{
	textureName = "./spritesheet/frame13.png";
};
datablock particleData(kenkoExplosionFrame14)
{
	textureName = "./spritesheet/frame14.png";
};
datablock particleData(kenkoExplosionFrame15)
{
	textureName = "./spritesheet/frame15.png";
};
datablock particleData(kenkoExplosionFrame16)
{
	textureName = "./spritesheet/frame16.png";
};

datablock particleData(kenkoExplosionParticle)
{
	dragCoefficient		= 0.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifeTime = 1000; 
	lifetimeVarianceMS	= 0;
	spinSpeed		= 0.0;
	spinRandomMin		= -0.0;
	spinRandomMax		= 0.0;
	textureName		= "./spritesheet/frame1.png";

	animTexName[0]= "./spritesheet/frame1.png";
	animTexName[1]= "./spritesheet/frame2.png";
	animTexName[2]= "./spritesheet/frame3.png";
	animTexName[3]= "./spritesheet/frame4.png";
	animTexName[4]= "./spritesheet/frame5.png";
	animTexName[5]= "./spritesheet/frame6.png";
	animTexName[6]= "./spritesheet/frame7.png";
	animTexName[7]= "./spritesheet/frame8.png";
	animTexName[8]= "./spritesheet/frame9.png";
	animTexName[9]= "./spritesheet/frame10.png";
	animTexName[10]= "./spritesheet/frame11.png";
	animTexName[11]= "./spritesheet/frame12.png";
	animTexName[12]= "./spritesheet/frame13.png";
	animTexName[13]= "./spritesheet/frame14.png";
	animTexName[14]= "./spritesheet/frame15.png";
	animTexName[15]= "./spritesheet/frame16.png";
	animateTexture= true;
	framesPerSec= 16;
	
	sizes[0] = 12.0;
	sizes[1] = 12.0;
};

datablock particleEmitterData(kenkoExplosionEmitter)
{
	ejectionPeriodMS = 1000;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = kenkoExplosionParticle;

   useEmitterColors = false;
   uiName = "Kenko Explosion";
};

datablock ExplosionData(kenkoExplosion)
{
   lifeTimeMS = 200;

   ParticleEmitter = kenkoExplosionEmitter;
   particleDensity = 1;
   particleRadius = 0.0;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.25;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 15;
   lightEndRadius = 11;
   lightStartColor = "0.45 0.3 0.1";
   lightEndColor = "0 0 0";

   //impulse
   impulseRadius = 12;
   impulseForce = 1200;

   //radius damage
   radiusDamage        = 120;
   damageRadius        = 8;
};
//particle dump end

AddDamageType("Kenko",   '<bitmap:add-ons/Weapon_Kenko/CI_kenko> %1',    '%2 <bitmap:add-ons/Weapon_Kenko/CI_kenko> %1',1.1,1);

datablock ProjectileData(kenkoProjectile) //T+T grenade code Lol!
{
	projectileShapeName = "./kenkoProjectile.dts";
	directDamage = 30;
	directDamageType = $DamageType::Kenko;
	radiusDamageType = $DamageType::Kenko;
	impactImpulse = 1200;
	verticalImpulse	 = 1200;
	//explosion = tierstickGrenadeExplosion;
	explosion = kenkoExplosion;
	//particleEmitter = tierstickGrenadeTrailEmitter;

	muzzleVelocity = 20;
	velInheritFactor = 0;
	explodeOnPlayerImpact = true;
	explodeOnDeath = true;

	// stickExplosion = stickExplosion; // doesn't show up
	brickExplosionRadius = 5;
	brickExplosionImpact = false; //destroy a brick if we hit it directly?
	brickExplosionForce	= 34;
	brickExplosionMaxVolume = 45; //max volume of bricks that we can destroy
	brickExplosionMaxVolumeFloating = 90; //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

	armingDelay	= 0; //volatile
	lifetime = 2000;
	//bounceAngle = 0; //sproing
	//minStickVelocity	= 10;
	fadeDelay = 3999;
	//bounceElasticity	= 0.3939; //sproing
	//bounceFriction		= 0;
	isBallistic = true;
	gravityMod = 1.0;

	hasLight = false;
	lightRadius = 3.0;
	lightColor = "0 0 0.5";

	uiName = "Kenko";
};

datablock ItemData(kenkoItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./kenkoWorld.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Kenko";
	iconName = "./icon_Kenko";

	 // Dynamic properties defined by the scripts
	image = kenkoImage;
	canDrop = true;
};

datablock ShapeBaseImageData(kenkoImage)
{
   // Basic Item properties
   shapeFile = "./kenkoItem.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "1.2 0 -1.2";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = kenkoItem;
   ammo = " ";
   projectile = kenkoProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   //melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   //doColorShift = true;
   //colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.3;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = bigCowSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.5;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "throw";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateScript[5]                  = "onStopFire";


};

function kenkoImage::onFire(%this, %obj, %slot)
{
	%parent = Parent::onFire(%this, %obj, %slot);
    %obj.playThread(2, spearthrow);
	return %parent;
}

function kenkoImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}

//hl1 explosion sounds to fit w/ the HEV suit hand
function kenkoProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal)
{
	Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
	%random = getRandom(1,3);
	switch(%random)
	{
		case 1:
			serverplay3d(kenko1Sound,%pos);
		case 2:
			serverplay3d(kenko2Sound,%pos);
		case 3:
			serverplay3d(kenko3Sound,%pos);
		default:
			echo("Kenko");
	}
}